// 6.11.2005   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                              BrainTrend2Stop.mq4 |
//|                                                www.forex-tsd.com |
//|                                                Nick Bilak        |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int Simbol   =119;
extern int CountBars=500;
//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//----
bool   river=True;
int    artp,limit,glava,p,Curr,f,s;
double Weight,r,r1,Range1,value3,spread;
double cecf,Emaxtra,widcha,TR,TR1,TR2,Values[100],ATR,low,high;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
  {
//---- indicator 0
   SetIndexStyle (0,DRAW_ARROW);
   SetIndexArrow (0,Simbol);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexEmptyValue(0,0.0);
//---- indicator 1  
   SetIndexStyle (1,DRAW_ARROW);
   SetIndexArrow( 1,Simbol);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexEmptyValue(1,0.0);
//----
   string short_name;
   short_name="BrainTrend2Stop";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexLabel(1,""+short_name+"_BUY" );
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//----
   spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
   cecf=0.7;artp=7;s=2;f=10;
//----
return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start() 
{
//---- 
   int Shift,J,counted_bars=IndicatorCounted();
//---- 
   if( CountBars > Bars-3) limit = Bars-3; else limit = CountBars-counted_bars-1;
   if( Close[limit + 2] > Close[limit + 1]) river = True; else river = False;
   Emaxtra = Close[limit + 1];
   glava=0;
//----
   for (Shift = limit; Shift>=0; Shift--) 
   { 
      low=Low [Shift];high=High[Shift];
      TR  = spread + high - low;
      TR1 = spread + high - Close[Shift + 1];
      TR2 = low - Close[Shift + 1];
      if (MathAbs(TR1) > TR) TR = MathAbs(TR1);
      if (MathAbs(TR2) > TR) TR = MathAbs(TR2);
      if (Shift == limit) for (J = 0; J<=artp - 1; J++)  Values[J] = TR;
      Values[glava] = TR;
      ATR = 0;
      Weight = artp;
      Curr = glava;
      for (J = 0; J<=artp - 1; J++) 
         {
         ATR += Values[Curr] * Weight;
         Weight -= 1;
         Curr -= 1;
         if (Curr == -1) Curr = artp - 1;
         }
      ATR = 2.0 * ATR / (artp * (artp + 1.0));
      glava += 1;
      if (glava == artp) glava = 0;
      widcha = cecf * ATR;
      if (river && low < Emaxtra - widcha) 
         {
         river = False;
         Emaxtra = spread + high;
         }
      if (!river && spread + high > Emaxtra + widcha) 
         {
         river = True;
         Emaxtra = low;
         }
      if (river && low > Emaxtra) Emaxtra = low;
      if (!river && spread + high < Emaxtra) Emaxtra = spread + high;        
      Range1 = (iATR(NULL,0,10,Shift)+spread/10.0) * s ;
      if (river) 
         {
         if (low - Range1 < r && r != 0)  r1 = r; else r1 = low - Range1 / 3.0;
         if (p == 2) r1 = low - Range1 / 3.0;
         Ind_Buffer1[Shift]=r1;
         Ind_Buffer2[Shift]=0; 
         r = r1;
         p = 1;
         } 
      else 
         {
         if (spread + high + Range1 > r && r != 0) r1 = r; else r1 = spread + high + Range1 / 3.0;
         if (p == 1) r1 = spread + high + Range1 / 3.0;
         Ind_Buffer1[Shift]=0;
         Ind_Buffer2[Shift]=r1; 
         r = r1;
         p = 2;
         }
   }      
//----
return(0);      
}

